#include "ACM.h"

using namespace std;
using namespace acm;
//定义监听器
class MyListener : public ManagerListener
{
public:
    MyListener(const std::string& data_id, const std::string& group):data_id_(data_id),group_(group){}
    virtual ~MyListener()
    {}
    virtual void getExecutor()
    {
        printf("data_id:%s group:%s getExecutor\n", \
        data_id_.c_str(), group_.c_str());
    }
    //回调函数
    virtual void receiveConfigInfo( std::string &configInfo)
    {
        printf("data_id:%s group:%s configInfo:\n%s\n", \
        data_id_.c_str(), group_.c_str(), configInfo.c_str());
        config_ = configInfo;
    }

private:
    std::string data_id_;
    std::string group_;
    std::string config_;
};


int main() {
    // 初始化配置服务，控制台通过示例代码自动获取下面参数
    ACM::init("${endpoint}", "${namespace}", "${accessKey}", "${secretKey}");

    //配置的dataId和group
    std::string dataId = "${dataId}";
    std::string group = "${group}";
    std::string content;
    //主动拉取配置
    ACM::getConfig(dataId, group, 5000, content);
    printf("get ok config %s\n", content.c_str());
    //监听配置的变更
    MyListener* listener = new MyListener(dataId, group);
    ACM::addListener(dataId, group, listener);
    printf("add listener ok %s %s\n", dataId.c_str(), group.c_str());
    do {
        printf("input q to quit\n");
    } while (getchar() != 'q');

    return 0;
}
